<?php

use Illuminate\Support\Facades\Input;

class CriteriaController extends \BaseController
{

    /**
     * Display a listing of the resource.
     *
     *
     * @return Response
     */
    public function editProgram()
    {
        $userProgram = Auth::user()['id'];

        $userProgram = DB::select("select program_user.program_id from program_user where user_id = {$userProgram}");
        Log::info($userProgram);
        $title = "Criteria";
        $outcomes = Outcome::orderBy('name', 'ASC')->lists('name', 'id');

        $criteria = Criterion::withTrashed()->orderBy('name', 'ASC')->get();
        $programs = Program::where("id", "=", $userProgram[0]->program_id)->get();
        return View::make('local.managers.pCoords.criteria', compact('title', 'outcomes', 'schools', 'criteria', 'programs', 'objectives'));
    }

    public function editSchool()
    {
        $userSchool = Auth::user()['school_id'];
        Log::info($userSchool);
        $title = "Criteria";
        $outcomes = Outcome::orderBy('name', 'ASC')->lists('name', 'id');

        $schools = School::find($userSchool)->get();
        $criteria = Criterion::withTrashed()->orderBy('name', 'ASC')->get();
        $programs = Program::where("school_id", "=", $userSchool)->orderBy('name', 'ASC')->get();
        $listOfId = array();
        foreach ($programs as $program) {

            $listOfId[] = $program->id;
        }

        $objectives = DB::table('objectives')->whereIn('program_id', $listOfId)->orderBy('text', 'ASC')->lists('text', 'id');





        return View::make('local.managers.sCoords.criteria', compact('title', 'outcomes', 'schools', 'criteria', 'programs', 'objectives'));
    }


    public function fetchCriterion()
    {
        return Criterion::find(Input::get('id'));
    }
    public function fetchAllCriterion()
    {
        $program_id = Input::get('program_fetch');
        $outcome_id = Input::get('outcome_fetch');
        $json = array();
        $json['criterion'] = DB::select("SELECT * FROM `new_criteria` where id in (select criterion_id from criterion_objective_outcome where outcome_id ={$outcome_id}) and id in(select criterion_id from program_criterion where program_id = {$program_id})");
        return json_encode($json);
    }
    public function fetchObjectivesForSelect()
    {

        $outcome = DB::select("select objectives.id, objectives.text, outcomes.name from objectives, objective_outcome, outcomes where  objective_outcome.outcome_id =? and objective_outcome.objective_id = objectives.id and objectives.active=1 and outcomes.id = objective_outcome.outcome_id", array(Input::get('id')));
        //
        return json_encode($outcome);
    }
    public function fetchCriterionWithTrashed()
    {

        $json = array();
        $json['criteria'] = DB::select(" select * from new_criteria where id = ?", array(Input::get('id')));
        $json['outcomes'] = DB::select("select  DISTINCT outcomes.id, outcomes.name from outcomes , criterion_objective_outcome where criterion_objective_outcome.criterion_id = ? and outcomes.id = criterion_objective_outcome.outcome_id order by outcomes.id", array(Input::get('id')));
        $json['objectives'] = DB::select("SELECT DISTINCT objectives.id, objectives.text FROM objectives, criterion_objective_outcome where criterion_objective_outcome.criterion_id = ? and criterion_objective_outcome.objective_id= objectives.id ", array(Input::get('id')));
        $json['objectives_outcome'] = DB::select("select objectives.id, objectives.text, objective_outcome.outcome_id from objective_outcome, objectives where objective_outcome.outcome_id in(select  DISTINCT outcomes.id from outcomes , criterion_objective_outcome where criterion_objective_outcome.criterion_id = ? and outcomes.id = criterion_objective_outcome.outcome_id) and objectives.id = objective_outcome.objective_id ORDER BY outcome_id", array(Input::get('id')));
        $json['scales'] = DB::select("select title, description, min_score, max_score from scales, criterion_scale where criterion_scale.scale_id = scales.id and criterion_id = ?", array(Input::get('id')));
        $json['program'] = DB::select("select criterion_id, program_id from program_criterion where criterion_id =?", array(Input::get('id')));
        $json['activity_criterion'] = DB::select("select * from assessments where activity_id  in (select activity_id from activity_criterion where criterion_id = ?)", array(Input::get('id')));

        return json_encode($json);
    }

    public function delete()
    {
        DB::delete("delete from new_criteria where id = ?", array(Input::get('criterion_delete')));
        $role = Auth::user()['role'];
        switch ($role) {
            case 1:
                return Redirect::to('criteria')->withInput();

            case 2:
                return Redirect::to('school-criteria')->withInput();

            case 3:
                return Redirect::to('program-criteria')->withInput();
        }
    }
    public function isCriterionUnique($input, $existing_criterion = NULL)
    {
        // dd($input);
        Log::info('isCriterionUnique');

        if (Input::get('program_id') != 0)
            $program_id = $input['program_id'];
        else
            $program_id = NULL;

        $saved_criterion = Criterion::withTrashed()
            ->where('name', '=', $input['name'])
            ->where('outcome_id', '=', $input['outcome_id'])
            ->where('program_id', '=', $program_id)
            ->first();



        if ($saved_criterion)
            return false;
        else
            return true;
    }

    private function cleanInput()
    {
        $clean_input = array();

        $clean_input['name'] = trim(preg_replace('/\t+/', '', Input::get('name')));


        $trimmed = trim(preg_replace('/\t+/', '', Input::get('subcriteria')));

        Log::info('trimmed 1 -->' . $trimmed . '<--');


        if ($trimmed == '') {
            $trimmed = NULL;
        } else {
            $trimmed = json_encode(preg_split('/\r\n/', $trimmed));
        }

        Log::info('trimmed 2 -->' . $trimmed . '<--');


        $clean_input['subcriteria'] = $trimmed;
        $clean_input['outcome_id'] = Input::get('outcome');



        $clean_input['objective_id'] = Input::get('objective');




        $clean_input['program_id'] = Input::get('program_id');

        $clean_input['copyright'] = trim(preg_replace('/\t+/', '', Input::get('copyright')));
        $clean_input['notes'] = trim(preg_replace('/\t+/', '', Input::get('notes')));
        $clean_input['maximum_score'] =  (int) Input::get('maximum_score');
        $clean_input['scale_title'] = Input::get('title');
        $clean_input['scale_description'] = Input::get('Scales');
        $clean_input['min_score'] = Input::get('min');
        $clean_input['max_score'] = Input::get('max');

        $clean_input['number_of_scales'] = sizeof($clean_input['scale_title']);


        return $clean_input;
    }

    private function makeValidator($clean_input)
    {
        /** Validation rules */
        return Validator::make(
            array(
                'name' => $clean_input['name'],
                'subcriteria' => $clean_input['subcriteria'],
                'outcome_id' => $clean_input['outcome_id'],
                'notes' => $clean_input['notes'],
                'copyright' => $clean_input['copyright'],
                'maximum_score' => $clean_input['maximum_score']
            ),
            array(
                'name' => 'required|string',
                'subcriteria' => 'string',
                'outcome_id' => 'required|array',

                'notes' => 'string',
                'copyright' => 'string',
                'maximum_score' => 'required|integer'
            )

        );
    }

    /**
     * Create a new criterion.
     *
     * @return Redirect Redirect back to form page
     */
    public function create()
    {
        $clean_input = $this->cleanInput();

        /** Validation rules */
        $validator = $this->makeValidator($clean_input);

        /** If validation fails */
        if ($validator->fails()) {
            /** Prepare error message */
            $message = '<p>Error(s) creating a new Criterion:</p><ul>';

            foreach ($validator->messages()->all('<li>:message</li>') as $validationError) {
                $message .= $validationError;
            }

            $message .= '</ul>';

            /** Send error message and old data */
            Session::flash('status', 'danger');
            Session::flash('message', $message);
            $role = Auth::user()['role'];
            switch ($role) {
                case 1:
                    return Redirect::to('criteria')->withInput();

                case 2:
                    return Redirect::to('school-criteria')->withInput();

                case 3:
                    return Redirect::to('program-criteria')->withInput();
            }
        } else {
            // Check criterion uniqueness
            /*if (!$this->isCriterionUnique($clean_input)) {
                /** Send error message and old data
                Session::flash('status', 'danger');
                Session::flash('message', 'This criterion is a duplicate of an already saved criterion because its name and associated program are the same.');
                return Redirect::to('criteria')->withInput();
            }*/

            /** Instantiate new criterion */
            $criterion = new Criterion;
            $criterion->name = $clean_input['name'];
            $criterion->subcriteria = $clean_input['subcriteria'];


            //gabriel añadió aqui

            $criterion->number_of_scales = $clean_input['number_of_scales'];
            $criterion->maximum_score = $clean_input['maximum_score'];

            if (Input::get('copyright'))
                $criterion->copyright = $clean_input['copyright'];

            if (Input::get('notes'))
                $criterion->notes = $clean_input['notes'];



            /** If criterion is saved, send success message */
            if ($criterion->save()) {

                $criterionId = $criterion->id;
                foreach ($clean_input['outcome_id'] as $outcome_id) {
                    foreach ($clean_input['objective_id'] as $objective_id) {

                        DB::insert("insert into `criterion_objective_outcome` (`objective_id`, `outcome_id`, `criterion_id`, `objective_outcome_id`) values ({$objective_id},{$outcome_id}, {$criterionId}, 0)");
                    }
                }

                for ($i = 0; $i < sizeof($clean_input['scale_title']); $i++) {
                    $scale = new Scale;
                    $scale->title = $clean_input['scale_title'][$i];
                    $scale->position = $i + 1;
                    $scale->description = $clean_input['scale_description'][$i];
                    $scale->min_score = $clean_input['min_score'][$i];
                    $scale->max_score = $clean_input['max_score'][$i];

                    if ($scale->save()) {
                        DB::insert("insert into `criterion_scale` (`criterion_id`, `scale_id`) values({$criterionId},{$scale->id})");
                    } else {
                        Session::flash('status', 'danger');
                        Session::flash('message', '<p>Error creating the Scales</p>');
                        $role = Auth::user()['role'];
                        switch ($role) {
                            case 1:
                                return Redirect::to('criteria')->withInput();

                            case 2:
                                return Redirect::to('school-criteria')->withInput();

                            case 3:
                                return Redirect::to('program-criteria')->withInput();
                        }
                    }
                }

                foreach ($clean_input['program_id'] as $program_id) {
                    DB::insert("insert into `program_criterion` (`criterion_id`, `program_id`) values({$criterionId},{$program_id})");
                }

                Session::flash('status', 'success');
                Session::flash('message', 'Criterion created: "' . $criterion->name . '".');
                $role = Auth::user()['role'];
                switch ($role) {
                    case 1:
                        return Redirect::to('criteria')->withInput();

                    case 2:
                        return Redirect::to('school-criteria')->withInput();

                    case 3:
                        return Redirect::to('program-criteria')->withInput();
                }
            }

            /** If saving fails, send error message and old data */
            else {
                Session::flash('status', 'danger');
                Session::flash('message', '<p>Error creating Criterion. Please try again later.</p>');
                $role = Auth::user()['role'];
                switch ($role) {
                    case 1:
                        return Redirect::to('criteria')->withInput();

                    case 2:
                        return Redirect::to('school-criteria')->withInput();

                    case 3:
                        return Redirect::to('program-criteria')->withInput();
                }
            }
        }
    }



    public function edit()
    {
        $title = "Criteria";
        $outcomes = Outcome::orderBy('name', 'ASC')->lists('name', 'id');

        $schools = School::orderBy('name', 'ASC')->get();
        $criteria = Criterion::withTrashed()->orderBy('name', 'ASC')->get();
        $programs = Program::orderBy('name', 'ASC')->get();
        $objectives = DB::table('objectives')->orderBy('text', 'ASC')->lists('text', 'id');





        return View::make('local.managers.admins.criteria', compact('title', 'outcomes', 'schools', 'criteria', 'programs', 'objectives'));
    }

    private function cleanInputEdit()
    {
        $clean_input = array();

        $clean_input['name'] = trim(preg_replace('/\t+/', '', Input::get('name')));


        $trimmed = trim(preg_replace('/\t+/', '', Input::get('subcriteria')));

        Log::info('trimmed 1 -->' . $trimmed . '<--');


        if ($trimmed == '') {
            $trimmed = NULL;
        } else {
            $trimmed = json_encode(preg_split('/\r\n/', $trimmed));
        }

        Log::info('trimmed 2 -->' . $trimmed . '<--');


        $clean_input['subcriteria'] = $trimmed;
        $clean_input['outcome_id'] = Input::get('assoc_outcome');



        $clean_input['objective_id'] = Input::get('assoc_objective');




        $clean_input['program_id'] = Input::get('program_id');

        $clean_input['copyright'] = trim(preg_replace('/\t+/', '', Input::get('copyright')));
        $clean_input['notes'] = trim(preg_replace('/\t+/', '', Input::get('notes')));
        $clean_input['maximum_score'] = (int) Input::get('assoc_maximum_score');
        $clean_input['scale_title'] = Input::get('assoc_title');
        $clean_input['scale_description'] = Input::get('assoc_scales');
        $clean_input['number_of_scales'] = sizeof($clean_input['scale_title']);


        return $clean_input;
    }

    public function update()
    {
        $criterion = Criterion::withTrashed()->find(Input::get('id'));

        $clean_input = $this->cleanInputEdit();

        /** Validation rules */
        $validator = $this->makeValidator($clean_input);

        /** If validation fails */
        if ($validator->fails()) {
            /** Prepare error message */
            $message = 'Error(s) updating the Criterion: <ul>';

            foreach ($validator->messages()->all('<li>:message</li>') as $validationError) {
                $message .= $validationError;
            }

            $message .= '</ul>';

            /** Send error message and old data */
            Session::flash('status', 'danger');
            Session::flash('message', $message);
            $role = Auth::user()['role'];
            switch ($role) {
                case 1:
                    return Redirect::to('objective')->withInput();

                case 2:
                    return Redirect::to('school-objective')->withInput();

                case 3:
                    return Redirect::to('program-objective')->withInput();
            }
        } else {

            // // Check criterion uniqueness
            // if(!$this->isCriterionUnique($clean_input, $criterion))
            // {
            //     /** Send error message and old data */
            //     Session::flash('status', 'danger');
            //     Session::flash('message', 'This criterion is a duplicate of an already saved criterion because its name, assoaciated school or program, and progress indicators are the same.');
            //     return Redirect::to('criteria')->withInput();
            // }

            /** Set info */
            $criterion->name = $clean_input['name'];
            $criterion->subcriteria = $clean_input['subcriteria'];



            $criterion->number_of_scales = $clean_input['number_of_scales'];
            $criterion->maximum_score = $clean_input['maximum_score'];



            // Set program
            if (Input::get('program_id') != 0)
                $criterion->program_id = Input::get('program_id');
            else
                $criterion->program_id = NULL;

            // Set status
            if (Input::get('status') == 0)
                $criterion->deleted_at = date('Y-m-d H:i:s');
            else
                $criterion->deleted_at = NULL;

            if (Input::get('copyright'))
                $criterion->copyright = $clean_input['copyright'];
            else
                $criterion->copyright = NULL;

            if (Input::get('notes'))
                $criterion->notes = $clean_input['notes'];
            else
                $criterion->notes = NULL;

            /** If criterion is updated, send success message */
            if ($criterion->save()) {
                $criterionId = $criterion->id;
                DB::delete("delete from `criterion_objective_outcome` where `criterion_id` ={$criterionId}");

                foreach ($clean_input['outcome_id'] as $outcome_id) {
                    foreach ($clean_input['objective_id'] as $objective_id) {

                        DB::insert("insert into `criterion_objective_outcome` (`objective_id`, `outcome_id`, `criterion_id`,`objective_outcome_id`) values ({$objective_id},{$outcome_id}, {$criterionId}, 0)");
                    }
                }
                DB::delete("delete from `scales` where id in (select scale_id id from criterion_scale where criterion_id = {$criterionId})");

                for ($i = 0; $i < sizeof($clean_input['scale_title']); $i++) {
                    $scale = new Scale;
                    $scale->title = $clean_input['scale_title'][$i];
                    $scale->position = $i + 1;
                    $scale->description = $clean_input['scale_description'][$i];
                    if ($scale->save()) {
                        DB::insert("insert into `criterion_scale` (`criterion_id`, `scale_id`) values({$criterionId},{$scale->id})");
                    } else {
                        Session::flash('status', 'danger');
                        Session::flash('message', '<p>Error creating the Scales</p>');
                        $role = Auth::user()['role'];
                        switch ($role) {
                            case 1:
                                return Redirect::to('objective')->withInput();

                            case 2:
                                return Redirect::to('school-objective')->withInput();

                            case 3:
                                return Redirect::to('program-objective')->withInput();
                        }
                    }
                }



                Session::flash('status', 'success');
                Session::flash('message', 'Updated criterion: "' . $criterion->name . '"');
                $role = Auth::user()['role'];
                switch ($role) {
                    case 1:
                        return Redirect::to('objective')->withInput();

                    case 2:
                        return Redirect::to('school-objective')->withInput();

                    case 3:
                        return Redirect::to('program-objective')->withInput();
                }
            }

            /** If saving fails, send error message and old data */
            else {
                Session::flash('status', 'danger');
                Session::flash('message', 'Error updating the Criterion. Please try again later.');
                $role = Auth::user()['role'];
                switch ($role) {
                    case 1:
                        return Redirect::to('objective')->withInput();

                    case 2:
                        return Redirect::to('school-objective')->withInput();

                    case 3:
                        return Redirect::to('program-objective')->withInput();
                }
            }
        }
    }
    // copie index() y lo edite
    public function objectivesIndex()
    {
        if (Auth::user()->role == 1) {
            //uscar todos los objetivos
            $objectives = DB::table('program_user')
                ->join('objectives', 'objectives.program_id', '=', 'program_user.program_id')
                ->join('programs', 'programs.id', '=', 'program_user.program_id')
                ->select('objectives.id', 'objectives.text', 'programs.name')
                ->orderBy('objectives.text', 'asc')
                ->get();
        } elseif (Auth::user()->role == 2) {
            //buscar los objetivos de la departamento (school)
            $objectives = DB::table('program_user')
                ->join('objectives', 'objectives.program_id', '=', 'program_user.program_id')
                ->join('programs', 'programs.id', '=', 'program_user.program_id')
                ->where('programs.school_id', Auth::user()->school_id)
                ->select('objectives.id', 'objectives.text', 'programs.name')
                ->orderBy('objectives.text', 'asc')
                ->get();
        } elseif ((Auth::user()->role == 3) || (Auth::user()->role == 4)) {
            //buscar los objetivos de los programas cuales el profesor esta
            $objectives = DB::table('program_user')
                ->join('objectives', 'objectives.program_id', '=', 'program_user.program_id')
                ->join('programs', 'programs.id', '=', 'program_user.program_id')
                ->where('program_user.user_id', Auth::user()->id)
                ->select('objectives.id', 'objectives.text', 'programs.name')
                ->orderBy('objectives.text', 'asc')
                ->get();
        }

        $title = "Learning Objectives and Criteria";

        return View::make('global.view-objectives-criteria', compact('title', 'objectives'));
    }
    public function index()
    {
        // el ID de los semestres que el usuario tiene seleccionado.
        $semesters_ids = Session::get('semesters_ids');
        // buscar informacion de los semestres seleccionados
        $semesters = Semester::whereIn('id', $semesters_ids)->get();

        $title = "Learning Outcomes and Criteria";
        $outcomes = Outcome::orderBy('name', 'ASC')->get();
        $schools = School::orderBy('name', 'ASC')->get();
        $criteria = Criterion::withTrashed()->orderBy('name', 'ASC')->get();

        // se annadio la nueva variable
        return View::make('global.view-learning-outcomes-criteria', compact('title', 'outcomes', 'schools', 'criteria', 'semesters'));

    }

    // copie index() y lo edite
    public function objectivesIndex()
    {
        if(Auth::user()->role==1)
        {
          //uscar todos los objetivos
          $objectives = DB::table('program_user')
                                ->join('objectives','objectives.program_id','=','program_user.program_id')
                                ->join('programs','programs.id','=','program_user.program_id')
                                ->select('objectives.id','objectives.text','programs.name')
                                ->orderBy('objectives.text', 'asc')
                                ->get();
        }
        elseif(Auth::user()->role==2)
        {
          //buscar los objetivos de la departamento (school)
          $objectives = DB::table('program_user')
                                ->join('objectives','objectives.program_id','=','program_user.program_id')
                                ->join('programs','programs.id','=','program_user.program_id')
                                ->where('programs.school_id',Auth::user()->school_id)
                                ->select('objectives.id','objectives.text','programs.name')
                                ->orderBy('objectives.text', 'asc')
                                ->get();
        }
        elseif((Auth::user()->role==3) || (Auth::user()->role==4))
        {
          //buscar los objetivos de los programas cuales el profesor esta
          $objectives = DB::table('program_user')
                                ->join('objectives','objectives.program_id','=','program_user.program_id')
                                ->join('programs','programs.id','=','program_user.program_id')
                                ->where('program_user.user_id',Auth::user()->id)
                                ->select('objectives.id','objectives.text','programs.name')
                                ->orderBy('objectives.text', 'asc')
                                ->get();
        }

        $title = "Learning Objectives and Criteria";

        return View::make('global.view-objectives-criteria', compact('title', 'objectives'));
    }

    public function destroy()
    {
        $criterion = Criterion::withTrashed()->find(Input::get('id'));
        if (!$criterion->trashed()) {
            try {
                $criterion->delete();
                Session::flash('status', 'success');
                Session::flash('message', 'Deactivated criterion: "' . $criterion->name . '"');
            } catch (Exception $e) {
                Session::flash('status', 'danger');
                Session::flash('message', 'Error deactivating criterion."' . $criterion->name . '"');
            }
            $role = Auth::user()['role'];
            switch ($role) {
                case 1:
                    return Redirect::to('objective')->withInput();

                case 2:
                    return Redirect::to('school-objective')->withInput();

                case 3:
                    return Redirect::to('program-objective')->withInput();
            }
        } else {
            try {
                $criterion->restore();
                Session::flash('status', 'success');
                Session::flash('message', 'Reactivated criterion: "' . $criterion->name . '"');
            } catch (Exception $e) {
                Session::flash('status', 'danger');
                Session::flash('message', 'Error reactivating criterion: "' . $criterion->name . '".');
            }
            $role = Auth::user()['role'];
            switch ($role) {
                case 1:
                    return Redirect::to('objective')->withInput();

                case 2:
                    return Redirect::to('school-objective')->withInput();

                case 3:
                    return Redirect::to('program-objective')->withInput();
            }
        }
    }

    public function filterCriteria()
    {
        switch (Input::get('filter')) {
            case 'all':
                return Criteria::all();
                break;

            case 'school':
                // If scoord
                if (Auth::user()->role == '2') {

                    // Fetch all the programs whose school is the user's
                    $program_ids = DB::table('programs')->where('school_id', Auth::user()->school_id)->lists('id');

                    // Return all criteria belonging to any of those programs
                    return Criterion::whereIn('program_id', $program_ids)
                        ->orderBy('name', 'ASC')
                        ->get();
                }

                // If pcoord
                else {
                    // Fetch all the programs from the user's school;
                    $program_ids = DB::table('programs')->where('school_id', Auth::user()->programs[0]->school->id)->lists('id');

                    return Criterion::whereIn('program_id', $program_ids)
                        ->orderBy('name', 'ASC')
                        ->get();
                }

                break;

            case 'program':
                return Criterion::whereIn('program_id', Auth::user()->programs->lists('id'))
                    ->orderBy('name', 'ASC')
                    ->get();
                break;

            default:
                return Criteria::all();
                break;
        }
    }
}
